/*  FBI_yrly_assault_offenses_BigORI.sas	*/
options nocenter ps=60 ls=72;
libname  sas  '/jackie/jc63/fbidata/';

filename  in1  
'/jackie/jc63/fbidata/FBI-yrly-assault-offenses-big-ori-w-moscnt.csv';
filename  out1 '/jackie/jc63/fbidata/FBI-Annual-Assault-offenses-bigORI.csv';
filename  out3 
'/jackie/jc63/fbidata/FBI-Annual-Assault-offenses-bigORI-all8797.csv';
filename missyr
'/jackie/jc63/fbidata/FBI-Annual-Assault-offenses-bigORI-find-missyear.txt';

data fbiyrly;
length ori $ 7;
infile in1 dsd missover lrecl=300;
input
	ID_CARD
	ORI $
	YEAR
	ASSTOTAL
	ASSGUN
	ASSKNIFE
	ASSOWEAP
	ASSUNARM
	ASSSIMP
	MOSREPT
	;

assagg = assgun + assknife + assoweap + assunarm;
assall = assagg + asssimp;

nomatch1 = .;
if assagg ne asstotal then nomatch1 = 1;
else if assagg = asstotal then nomatch1 = 0;

nomatch2 = .;
if assall ne asstotal then nomatch2 = 1;
else if assall = asstotal then nomatch2 = 0;

if year > 86 and year < 98;

run;
 
proc sort data=fbiyrly;
by ori year id_card;
run;

proc freq data=fbiyrly;
table year*id_card*mosrept / list nopercent norow nocol missing;
title 'Number ORIs by mos reported per year';
run;

proc freq data=fbiyrly;
table year*id_card*nomatch1 year*id_card*nomatch2 
      / list nopercent norow nocol missing;
title 'Differences in monthly counts agg  v all';
run;

proc sort data=fbiyrly;
by ori year;
run;

data check1;
set fbiyrly;
by ori;
if first.ori then nomatch = 0;
if nomatch2=1 then nomatch + 1;
if last.ori then output;

data check2 (keep=ori);
set check1;
if nomatch>0;

proc sort data=check2;
by ori;

data check3;
merge fbiyrly (in=a) check2 (in=b);
by ori;
if b;
if nomatch2=1;

proc print data=check3;
var ori id_card year asstotal assall assagg nomatch2;
title 'Records with unmatched total assaults';


data yrly;
set fbiyrly;
if (ori="OHCOP00") 
or (ori="AZ00723");
if (year = 87) or (year = 97);
run;
proc print data=yrly;
var ori year id_card mosrept asstotal assagg assall assgun;
title 'Sample Yearly Offenses Data Extract';
run;


data unfound (keep=ori year ufasstot ufassgun ufassknf ufassowp 
                   ufassnwp ufasssim ufassagg ufassall ufmosrep);
set fbiyrly;
if (id_card = 0) and (year > 86) and (year < 98);
	ufasstot = asstotal;
	ufassgun = ASSGUN;
	ufassknf = ASSKNIFE;
	ufassowp = ASSOWEAP;
	ufassnwp = ASSUNARM;
	ufasssim = ASSSIMP;
	ufassagg = assagg;
	ufassall = assall;
        ufmosrep = mosrept;

proc sort data=unfound;
by ori year;

data actual (keep=ori year acasstot acassgun acassknf acassowp 
                   acassnwp acasssim acassagg acassall acmosrep);
set fbiyrly;
if (id_card = 1) and (year > 86) and (year < 98);
	acasstot = asstotal;
	acassgun = ASSGUN;
	acassknf = ASSKNIFE;
	acassowp = ASSOWEAP;
	acassnwp = ASSUNARM;
	acasssim = ASSSIMP;
	acassagg = assagg;
	acassall = assall;
        acmosrep = mosrept;

proc sort data=actual;
by ori year;

data cleared (keep=ori year classtot classgun classknf classowp 
                   classnwp classsim classagg classall clmosrep);
set fbiyrly;
if (id_card = 2) and (year > 86) and (year < 98);
	classtot = asstotal;
	classgun = ASSGUN;
	classknf = ASSKNIFE;
	classowp = ASSOWEAP;
	classnwp = ASSUNARM;
	classsim = ASSSIMP;
	classagg = assagg;
	classall = assall;
        clmosrep = mosrept;

proc sort data=cleared;
by ori year;

data nounfnd;
merge unfound (in=a) actual (in=b);
by ori year;
if b and not a;

proc print data=nounfnd;
var ori year;
title 'Agencies with no unfounded reports';

data noclrd;
merge cleared (in=a) actual (in=b);
by ori year;
if b and not a;

proc print data=noclrd;
var ori year;
title 'Agencies with no cleared reports';

data alltypes;
merge unfound (in=a) actual (in=b) cleared (in=c);
by ori year;
if a and b and c;
/*  Number of ori-years with all 3 yearly record types  */

data offense;
merge unfound (in=a) actual (in=b) cleared (in=c);
by ori year;
if a or b or c;
/*  Number of ori-years with any of 3 yearly record types  */

data year;
set offense;
if (ori="OHCOP00") 
or (ori="AZ00723");
if (year = 87) or (year = 97);
run;
proc print data=year;
var ori year acmosrep acasstot acassagg acassall acassgun;
title 'Sample Yearly Data Extract actual assaults';
run;

proc freq data=offense;
table year*acmosrep*ufmosrep*clmosrep / list nopercent norow nocol missing;
title 'Frequency of agencies by months reported each year';
run;

proc sort data=offense;
by ori year;
run;



/* ORIs with full year data unfounded, actual, & cleared  */
data _null_;
set offense;
file out3;
put 
	ori	','
	year	','
	ufmosrep ','
	ufasstot ','
	ufassagg ','
	ufassall ','
	ufassgun ','
	ufassknf ','
	ufassowp ','
	ufassnwp ','
	ufasssim ','
	acmosrep ','
	acasstot ','
	acassagg ','
	acassall ','
	acassgun ','
	acassknf ','
	acassowp ','
	acassnwp ','
	acasssim ','
	clmosrep ','
	classtot ','
	classagg ','
	classall ','
	classgun ','
	classknf ','
	classowp ','
	classnwp ','
	classsim
	;

/*  find missing years  */
proc print data=offense;
var ori year ufasstot acasstot classtot;
title 'Find missing years';


data keepyear;
set offense;
if (acmosrep=12) and (ufmosrep=12) and clmosrep = 12;
if (year > 86) and (year < 98);

proc sort data=keepyear;
by ori year;
run;

proc freq data=keepyear;
table year / list nopercent norow nocol missing;
title 'Number of ORIs with full year data unfounded, actual & cleared';


data fyear;
set keepyear;
if (ori="OHCOP00") 
or (ori="AZ00723");
if (year = 87) or (year = 97);
run;
proc print data=fyear;
var ori year acmosrep acasstot acassagg acassall acassgun;

title 'Sample ORI-Years w-12mos Data Unfounded Actual & Cleared Data Extract';
run;

data cntfyear (keep=ori yearcnt);
set keepyear;
by ori year;
if first.ori then yearcnt = 0;
yearcnt + 1;
if last.ori then output;
run;

proc sort data=cntfyear;
by ori;
run;

proc freq data=cntfyear;
table yearcnt / list norow nocol nopercent missing;
title 'Frequency of agencies by number years w-12 mos data 1987-97';
run;

data select;
set cntfyear;
if yearcnt>8;
run;

proc sort data=select;
by ori yearcnt;
run;


data keeper (keep=ori year acmosrep acasstot acassagg acassall acassgun
			   acassknf acassowp acassnwp acasssim
                           ufmosrep ufasstot ufassagg ufassall ufassgun
			   ufassknf ufassowp ufassnwp ufasssim
                           clmosrep classtot classagg classall classgun
			   classknf classowp classnwp classsim);
merge select (in=a) keepyear (in=b);
by ori;
if a;
run;

proc freq data=keeper;
table year / list norow nocol nopercent missing;
title 'Number of ORIs with >8 yrs full year data unfounded actual & cleared';

data kpyear;
set keeper;
if (ori="OHCOP00") 
or (ori="AZ00723");
if (year = 87) or (year = 97);
run;
proc print data=kpyear;
var ori year acmosrep acasstot acassagg acassall acassgun;
title 'Sample ORI-Years >8 yrs w-12mos Data Agg & Simple Ass Extract';
run;

data _null_;
set keeper;
file out1;
put	
	ori	','
	year	','
	ufmosrep ','
	ufasstot ','
	ufassagg ','
	ufassall ','
	ufassgun ','
	ufassknf ','
	ufassowp ','
	ufassnwp ','
	ufasssim ','
	acmosrep ','
	acasstot ','
	acassagg ','
	acassall ','
	acassgun ','
	acassknf ','
	acassowp ','
	acassnwp ','
	acasssim ','
	clmosrep ','
	classtot ','
	classagg ','
	classall ','
	classgun ','
	classknf ','
	classowp ','
	classnwp ','
	classsim
	;

data fyr87ac;
set fbiyrly;
if id_card=1 and year = 87 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr87ac;
by ori year;
run;

data fyr87uf;
set fbiyrly;
if id_card=0 and year = 87 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr87uf;
by ori year;
run;

data fyr87cl;
set fbiyrly;
if id_card=2 and year = 87 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr87cl;
by ori year;
run;

data fyr88ac;
set fbiyrly;
if id_card=1 and year = 88 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr88ac;
by ori year;
run;

data fyr88uf;
set fbiyrly;
if id_card=0 and year = 88 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr88uf;
by ori year;
run;

data fyr88cl;
set fbiyrly;
if id_card=2 and year = 88 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr88cl;
by ori year;
run;

data fyr89ac;
set fbiyrly;
if id_card=1 and year = 89 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr89ac;
by ori year;
run;

data fyr89uf;
set fbiyrly;
if id_card=0 and year = 89 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr89uf;
by ori year;
run;

data fyr89cl;
set fbiyrly;
if id_card=2 and year = 89 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr89cl;
by ori year;
run;

data fyr90ac;
set fbiyrly;
if id_card=1 and year = 90 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr90ac;
by ori year;
run;

data fyr90uf;
set fbiyrly;
if id_card=0 and year = 90 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr90uf;
by ori year;
run;

data fyr90cl;
set fbiyrly;
if id_card=2 and year = 90 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr90cl;
by ori year;
run;

data fyr91ac;
set fbiyrly;
if id_card=1 and year = 91 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr91ac;
by ori year;
run;

data fyr91uf;
set fbiyrly;
if id_card=0 and year = 91 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr91uf;
by ori year;
run;

data fyr91cl;
set fbiyrly;
if id_card=2 and year = 91 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr91cl;
by ori year;
run;

data fyr92ac;
set fbiyrly;
if id_card=1 and year = 92 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr92ac;
by ori year;
run;

data fyr92uf;
set fbiyrly;
if id_card=0 and year = 92 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr92uf;
by ori year;
run;

data fyr92cl;
set fbiyrly;
if id_card=2 and year = 92 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr92cl;
by ori year;
run;

data fyr93ac;
set fbiyrly;
if id_card=1 and year = 93 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr93ac;
by ori year;
run;

data fyr93uf;
set fbiyrly;
if id_card=0 and year = 93 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr93uf;
by ori year;
run;

data fyr93cl;
set fbiyrly;
if id_card=2 and year = 93 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr93cl;
by ori year;
run;

data fyr94ac;
set fbiyrly;
if id_card=1 and year = 94 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr94ac;
by ori year;
run;

data fyr94uf;
set fbiyrly;
if id_card=0 and year = 94 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr94uf;
by ori year;
run;

data fyr94cl;
set fbiyrly;
if id_card=2 and year = 94 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr94cl;
by ori year;
run;

data fyr95ac;
set fbiyrly;
if id_card=1 and year = 95 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr95ac;
by ori year;
run;

data fyr95uf;
set fbiyrly;
if id_card=0 and year = 95 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr95uf;
by ori year;
run;

data fyr95cl;
set fbiyrly;
if id_card=2 and year = 95 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr95cl;
by ori year;
run;

data fyr96ac;
set fbiyrly;
if id_card=1 and year = 96 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr96ac;
by ori year;
run;

data fyr96uf;
set fbiyrly;
if id_card=0 and year = 96 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr96uf;
by ori year;
run;

data fyr96cl;
set fbiyrly;
if id_card=2 and year = 96 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr96cl;
by ori year;
run;

data fyr97ac;
set fbiyrly;
if id_card=1 and year = 97 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr97ac;
by ori year;
run;

data fyr97uf;
set fbiyrly;
if id_card=0 and year = 97 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr97uf;
by ori year;
run;

data fyr97cl;
set fbiyrly;
if id_card=2 and year = 97 and asstotal>0 and mosrept = 12;
run;
proc sort data=fyr97cl;
by ori year;
run;


data allact (keep=ori);
merge fyr87ac (in=a)
      fyr88ac (in=b)
      fyr89ac (in=c)
      fyr90ac (in=d)
      fyr91ac (in=e)
      fyr92ac (in=f)
      fyr93ac (in=g)
      fyr94ac (in=h)
      fyr95ac (in=i)
      fyr96ac (in=j)
      fyr97ac (in=k);
by ori;
if a and b and c and d and e and f and g and h and i and j and k;
run;
/* ******************************************************************* */
/*  Number of agencies with actual assault counts in all years 1987-97 */
/* ******************************************************************* */

data alluf (keep=ori);
merge fyr87uf (in=a)
      fyr88uf (in=b)
      fyr89uf (in=c)
      fyr90uf (in=d)
      fyr91uf (in=e)
      fyr92uf (in=f)
      fyr93uf (in=g)
      fyr94uf (in=h)
      fyr95uf (in=i)
      fyr96uf (in=j)
      fyr97uf (in=k);
by ori;
if a and b and c and d and e and f and g and h and i and j and k;
run;
/* ********************************************************************** */
/*  Number of agencies with unfounded assault counts in all years 1987-97 */
/* ********************************************************************** */

data allcl (keep=ori);
merge fyr87cl (in=a)
      fyr88cl (in=b)
      fyr89cl (in=c)
      fyr90cl (in=d)
      fyr91cl (in=e)
      fyr92cl (in=f)
      fyr93cl (in=g)
      fyr94cl (in=h)
      fyr95cl (in=i)
      fyr96cl (in=j)
      fyr97cl (in=k);
by ori;
if a and b and c and d and e and f and g and h and i and j and k;
run;
/* ******************************************************************** */
/*  Number of agencies with cleared assault counts in all years 1987-97 */
/* ******************************************************************** */

data all (keep=ori);
merge fyr87ac (in=a) fyr87uf (in=aa) fyr87cl (in=ab)
      fyr88ac (in=b) fyr88uf (in=ba) fyr88cl (in=bb)
      fyr89ac (in=c) fyr89uf (in=ca) fyr89cl (in=cb)
      fyr90ac (in=d) fyr90uf (in=da) fyr90cl (in=db)
      fyr91ac (in=e) fyr91uf (in=ea) fyr91cl (in=eb)
      fyr92ac (in=f) fyr92uf (in=fa) fyr92cl (in=fb)
      fyr93ac (in=g) fyr93uf (in=ga) fyr93cl (in=gb)
      fyr94ac (in=h) fyr94uf (in=ha) fyr94cl (in=hb)
      fyr95ac (in=i) fyr95uf (in=ia) fyr95cl (in=ib)
      fyr96ac (in=j) fyr96uf (in=ja) fyr96cl (in=jb)
      fyr97ac (in=k) fyr97uf (in=ka) fyr97cl (in=kb);
by ori;
if a and b and c and d and e and f and g and h and i and j and k and
aa and ba and ca and da and ea and fa and ga and ha and ia and ja and ka and
ab and bb and cb and db and eb and fb and gb and hb and ib and jb and kb;
run;
/* *********************************************************************** */
/*  Number of agencies with actual unfounded & cleared assault in all years*/
/* *********************************************************************** */


data anyact (keep=ori);
merge fyr87ac (in=a)
      fyr88ac (in=b)
      fyr89ac (in=c)
      fyr90ac (in=d)
      fyr91ac (in=e)
      fyr92ac (in=f)
      fyr93ac (in=g)
      fyr94ac (in=h)
      fyr95ac (in=i)
      fyr96ac (in=j)
      fyr97ac (in=k);
by ori;
if a or b or c or d or e or f or g or h or i or j or k;
run;
/* ******************************************************************* */
/*  Number of agencies with actual assault counts in any years 1987-97 */
/* ******************************************************************* */

data anyuf (keep=ori);
merge fyr87uf (in=a)
      fyr88uf (in=b)
      fyr89uf (in=c)
      fyr90uf (in=d)
      fyr91uf (in=e)
      fyr92uf (in=f)
      fyr93uf (in=g)
      fyr94uf (in=h)
      fyr95uf (in=i)
      fyr96uf (in=j)
      fyr97uf (in=k);
by ori;
if a or b or c or d or e or f or g or h or i or j or k;
run;
/* ********************************************************************** */
/*  Number of agencies with unfounded assault counts in any years 1987-97 */
/* ********************************************************************** */

data anycl (keep=ori);
merge fyr87cl (in=a)
      fyr88cl (in=b)
      fyr89cl (in=c)
      fyr90cl (in=d)
      fyr91cl (in=e)
      fyr92cl (in=f)
      fyr93cl (in=g)
      fyr94cl (in=h)
      fyr95cl (in=i)
      fyr96cl (in=j)
      fyr97cl (in=k);
by ori;
if a or b or c or d or e or f or g or h or i or j or k;
run;
/* ******************************************************************** */
/*  Number of agencies with cleared assault counts in any years 1987-97 */
/* ******************************************************************** */

data any (keep=ori);
merge fyr87ac (in=a) fyr87uf (in=aa) fyr87cl (in=ab)
      fyr88ac (in=b) fyr88uf (in=ba) fyr88cl (in=bb)
      fyr89ac (in=c) fyr89uf (in=ca) fyr89cl (in=cb)
      fyr90ac (in=d) fyr90uf (in=da) fyr90cl (in=db)
      fyr91ac (in=e) fyr91uf (in=ea) fyr91cl (in=eb)
      fyr92ac (in=f) fyr92uf (in=fa) fyr92cl (in=fb)
      fyr93ac (in=g) fyr93uf (in=ga) fyr93cl (in=gb)
      fyr94ac (in=h) fyr94uf (in=ha) fyr94cl (in=hb)
      fyr95ac (in=i) fyr95uf (in=ia) fyr95cl (in=ib)
      fyr96ac (in=j) fyr96uf (in=ja) fyr96cl (in=jb)
      fyr97ac (in=k) fyr97uf (in=ka) fyr97cl (in=kb);
by ori;
if a or b or c or d or e or f or g or h or i or j or k or
aa or ba or ca or da or ea or fa or ga or ha or ia or ja or ka or
ab or bb or cb or db or eb or fb or gb or hb or ib or jb or kb;
run;
/* *********************************************************************** */
/*  Number of agencies with actual unfounded & cleared assault in any years*/
/* *********************************************************************** */




